package labss.lang;

import static org.whole.lang.iterators.IteratorFactory.matcherIterator;

import java.util.HashSet;
import java.util.Set;

import labss.lang.il.factories.ILEntityFactory;
import labss.lang.il.model.Variable;
import labss.lang.il.reflect.ILEntityDescriptorEnum;
import labss.lang.il.reflect.ILLanguageDeployer;
import labss.lang.il.reflect.ILOperationsDeployer;

import org.whole.lang.bindings.IBindingManager;
import org.whole.lang.commons.reflect.CommonsLanguageDeployer;
import org.whole.lang.iterators.IteratorFactory;
import org.whole.lang.model.IEntity;
import org.whole.lang.operations.InterpreterOperation;
import org.whole.lang.operations.PrettyPrinterOperation;
import org.whole.lang.queries.model.PathExpression;
import org.whole.lang.queries.util.QueriesUtils;
import org.whole.lang.reflect.ReflectionFactory;
import org.whole.lang.xml.codebase.XmlBuilderPersistenceKit;
import org.whole.langs.core.CoreLanguagesDeployer;
import org.whole.langs.legacy.LegacyLanguagesDeployer;

public class TestFatt {
	public static void main(String[] args) throws Exception {
		//inizializzazione dei linguaggi che si vogliono usare
		ReflectionFactory.deploy(CommonsLanguageDeployer.class);
		ReflectionFactory.deploy(CoreLanguagesDeployer.class);
		ReflectionFactory.deploy(LegacyLanguagesDeployer.class);
		ReflectionFactory.deploy(ILLanguageDeployer.class);

		//carico il modello (xml) del programma fattoriale e lo stampo
		IEntity p = XmlBuilderPersistenceKit.instance().readModel(TestFatt.class.getResourceAsStream("progFatt.xml"));
		PrettyPrinterOperation.prettyPrint(p);
		
//... se lo avessi salvato in java sarebbe stato pi comodo da caricare
//		IEntity p2 = new progFatt().create();
//		PrettyPrinterOperation.prettyPrint(p2);

// in alternativa ho a disposizione delle API creazionali per costruire il programma
		ILEntityFactory ef = ILEntityFactory.instance;
		IEntity p3 = ef.createBlockStatement(
				ef.createAssignmentStatement(ef.createVariable("n"), ef.createIntLiteral(4)),
				ef.createAssignmentStatement(ef.createVariable("result"), ef.createIntLiteral(1)),
				ef.createWhileStatement(ef.createGreaterThan(ef.createVariable("n"), ef.createIntLiteral(0)), ef.createBlockStatement(
						ef.createAssignmentStatement(ef.createVariable("result"), ef.createMultiplication(
								ef.createVariable("result"), ef.createVariable("n"))),
						ef.createAssignmentStatement(ef.createVariable("n"), ef.createSubtraction(
								ef.createVariable("n"), ef.createIntLiteral(1)))
				)));
		PrettyPrinterOperation.prettyPrint(p3);

		//inizializzazione delle operazioni definite su IL
		ReflectionFactory.deploy(ILOperationsDeployer.class);
		
		IBindingManager bm = InterpreterOperation.interpret(p3);
		int result = bm.wIntValue("result");
		System.out.println("result = "+result);
		
		PrettyPrinterOperation.prettyPrint(p3);
		
		
		System.out.println("\n*** used variables: (iterator)");
		Set<String> vars = new HashSet<String>();
		for (Variable v : matcherIterator(IteratorFactory.<Variable>descendantOrSelfIterator(p3)).usePattern(ILEntityDescriptorEnum.Variable))
			if (vars.add(v.getValue()))
				System.out.println("var: "+v.getValue());


		System.out.println("\n*** used variables: (queries)");
		PathExpression pe = (PathExpression) TestQueriesTemplatesFactory.instance().create("usedVariables");
		for (Variable v : QueriesUtils.<Variable>iterator(pe, p3))
			System.out.println("var: "+v.getValue());
	}
}
