package labss.lang.il.factories;

import org.whole.lang.factories.GenericEntityFactory;
import labss.lang.il.model.*;
import org.whole.lang.factories.RegistryConfigurations;
import org.whole.lang.factories.IEntityRegistryProvider;
import labss.lang.il.reflect.ILEntityDescriptorEnum;
import org.whole.lang.model.IEntity;
import org.whole.lang.factories.IEntityBuilder;
import org.whole.lang.factories.EntityBuilder;

/** 
 * @generator Whole
 */
public class ILEntityFactory extends GenericEntityFactory {
	public static final ILEntityFactory instance = instance(RegistryConfigurations.DEFAULT);

	public static ILEntityFactory instance(IEntityRegistryProvider provider) {
		return new ILEntityFactory(provider);
	}

	protected ILEntityFactory(IEntityRegistryProvider provider) {
		super(provider);
	}

	public BlockStatement createBlockStatement() {
		return create(ILEntityDescriptorEnum.BlockStatement);
	}

	public BlockStatement createBlockStatement(Statement... entities) {
		return create(ILEntityDescriptorEnum.BlockStatement,
				(IEntity[]) entities);
	}

	public BlockStatement createBlockStatement(int initialSize) {
		return clone(ILEntityDescriptorEnum.BlockStatement, initialSize);
	}

	public IfStatement createIfStatement() {
		return create(ILEntityDescriptorEnum.IfStatement);
	}

	public IfStatement createIfStatement(Expression condition,
			Statement trueBody) {
		return create(ILEntityDescriptorEnum.IfStatement, condition, trueBody);
	}

	public IEntityBuilder<IfStatement> buildIfStatement() {
		return new EntityBuilder<IfStatement>(
				create(ILEntityDescriptorEnum.IfStatement));
	}

	public IfElseStatement createIfElseStatement() {
		return create(ILEntityDescriptorEnum.IfElseStatement);
	}

	public IfElseStatement createIfElseStatement(Expression condition,
			Statement trueBody, Statement falseBody) {
		return create(ILEntityDescriptorEnum.IfElseStatement, condition,
				trueBody, falseBody);
	}

	public IEntityBuilder<IfElseStatement> buildIfElseStatement() {
		return new EntityBuilder<IfElseStatement>(
				create(ILEntityDescriptorEnum.IfElseStatement));
	}

	public WhileStatement createWhileStatement() {
		return create(ILEntityDescriptorEnum.WhileStatement);
	}

	public WhileStatement createWhileStatement(Expression condition,
			Statement trueBody) {
		return create(ILEntityDescriptorEnum.WhileStatement, condition,
				trueBody);
	}

	public IEntityBuilder<WhileStatement> buildWhileStatement() {
		return new EntityBuilder<WhileStatement>(
				create(ILEntityDescriptorEnum.WhileStatement));
	}

	public AssignmentStatement createAssignmentStatement() {
		return create(ILEntityDescriptorEnum.AssignmentStatement);
	}

	public AssignmentStatement createAssignmentStatement(Variable variable,
			Expression expression) {
		return create(ILEntityDescriptorEnum.AssignmentStatement, variable,
				expression);
	}

	public IEntityBuilder<AssignmentStatement> buildAssignmentStatement() {
		return new EntityBuilder<AssignmentStatement>(
				create(ILEntityDescriptorEnum.AssignmentStatement));
	}

	public BooleanLiteral createBooleanLiteral() {
		return create(ILEntityDescriptorEnum.BooleanLiteral);
	}

	public BooleanLiteral createBooleanLiteral(boolean value) {
		return create(ILEntityDescriptorEnum.BooleanLiteral, value);
	}

	public IntLiteral createIntLiteral() {
		return create(ILEntityDescriptorEnum.IntLiteral);
	}

	public IntLiteral createIntLiteral(int value) {
		return create(ILEntityDescriptorEnum.IntLiteral, value);
	}

	public Variable createVariable() {
		return create(ILEntityDescriptorEnum.Variable);
	}

	public Variable createVariable(String value) {
		return create(ILEntityDescriptorEnum.Variable, value);
	}

	public Addition createAddition() {
		return create(ILEntityDescriptorEnum.Addition);
	}

	public Addition createAddition(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.Addition, exp1, exp2);
	}

	public IEntityBuilder<Addition> buildAddition() {
		return new EntityBuilder<Addition>(
				create(ILEntityDescriptorEnum.Addition));
	}

	public Subtraction createSubtraction() {
		return create(ILEntityDescriptorEnum.Subtraction);
	}

	public Subtraction createSubtraction(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.Subtraction, exp1, exp2);
	}

	public IEntityBuilder<Subtraction> buildSubtraction() {
		return new EntityBuilder<Subtraction>(
				create(ILEntityDescriptorEnum.Subtraction));
	}

	public Multiplication createMultiplication() {
		return create(ILEntityDescriptorEnum.Multiplication);
	}

	public Multiplication createMultiplication(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.Multiplication, exp1, exp2);
	}

	public IEntityBuilder<Multiplication> buildMultiplication() {
		return new EntityBuilder<Multiplication>(
				create(ILEntityDescriptorEnum.Multiplication));
	}

	public Division createDivision() {
		return create(ILEntityDescriptorEnum.Division);
	}

	public Division createDivision(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.Division, exp1, exp2);
	}

	public IEntityBuilder<Division> buildDivision() {
		return new EntityBuilder<Division>(
				create(ILEntityDescriptorEnum.Division));
	}

	public And createAnd() {
		return create(ILEntityDescriptorEnum.And);
	}

	public And createAnd(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.And, exp1, exp2);
	}

	public IEntityBuilder<And> buildAnd() {
		return new EntityBuilder<And>(create(ILEntityDescriptorEnum.And));
	}

	public Or createOr() {
		return create(ILEntityDescriptorEnum.Or);
	}

	public Or createOr(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.Or, exp1, exp2);
	}

	public IEntityBuilder<Or> buildOr() {
		return new EntityBuilder<Or>(create(ILEntityDescriptorEnum.Or));
	}

	public Not createNot() {
		return create(ILEntityDescriptorEnum.Not);
	}

	public Not createNot(Expression exp) {
		return create(ILEntityDescriptorEnum.Not, exp);
	}

	public Equals createEquals() {
		return create(ILEntityDescriptorEnum.Equals);
	}

	public Equals createEquals(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.Equals, exp1, exp2);
	}

	public IEntityBuilder<Equals> buildEquals() {
		return new EntityBuilder<Equals>(create(ILEntityDescriptorEnum.Equals));
	}

	public LessThan createLessThan() {
		return create(ILEntityDescriptorEnum.LessThan);
	}

	public LessThan createLessThan(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.LessThan, exp1, exp2);
	}

	public IEntityBuilder<LessThan> buildLessThan() {
		return new EntityBuilder<LessThan>(
				create(ILEntityDescriptorEnum.LessThan));
	}

	public GreaterThan createGreaterThan() {
		return create(ILEntityDescriptorEnum.GreaterThan);
	}

	public GreaterThan createGreaterThan(Expression exp1, Expression exp2) {
		return create(ILEntityDescriptorEnum.GreaterThan, exp1, exp2);
	}

	public IEntityBuilder<GreaterThan> buildGreaterThan() {
		return new EntityBuilder<GreaterThan>(
				create(ILEntityDescriptorEnum.GreaterThan));
	}
}
