package labss.lang.il.reflect;

import labss.lang.il.visitors.ILInterpreterVisitor;
import labss.lang.il.visitors.ILPrettyPrinterVisitor;

import org.whole.lang.operations.IOperation;
import org.whole.lang.operations.InterpreterOperation;
import org.whole.lang.operations.PrettyPrinterOperation;
import org.whole.lang.reflect.AbstractDeployer;
import org.whole.lang.reflect.IDeployer;
import org.whole.lang.reflect.ReflectionFactory;
import org.whole.lang.visitors.IVisitor;
import org.whole.lang.visitors.IVisitorFactory;

/** 
 * @author Riccardo Solmi
 */
public class ILOperationsDeployer extends AbstractDeployer {
	public int getDeployLevel() {
		return IDeployer.LEVEL_LANGUAGE_EXTENSION;
	}

	public void deploy(ReflectionFactory platform) {
		platform.addOperationFactory(ILLanguageKit.ID, InterpreterOperation.ID,
				new IVisitorFactory() {
			public IVisitor create(IOperation operation, int stage) {
				if (stage == 0)
					return new ILInterpreterVisitor((InterpreterOperation) operation);
				else
					return null;
			}
		});
		platform.addOperationFactory(ILLanguageKit.ID, PrettyPrinterOperation.ID,
				new IVisitorFactory() {
			public IVisitor create(IOperation operation, int stage) {
				if (stage == 0)
					return new ILPrettyPrinterVisitor((PrettyPrinterOperation) operation);
				else
					return null;
			}
		});
	}
}
