package labss.lang.il.visitors;

import org.whole.lang.visitors.GenericTraversalFactory;
import org.whole.lang.visitors.IVisitor;
import org.whole.lang.visitors.IBinaryVisitor;
import org.whole.lang.visitors.IUnaryVisitor;

/** 
 * @generator Whole
 */
public class ILTraversalFactory extends GenericTraversalFactory {
	public static final ILTraversalFactory instance = new ILTraversalFactory();

	private ILTraversalFactory() {
	}

	protected IVisitor ensureSpecific(IVisitor visitor) {
		if (visitor instanceof IILVisitor)
			return visitor;
		else
			return new ILForwardGenericVisitor(visitor);
	}

	public IVisitor failure() {
		return new ILFailureVisitor();
	}

	public IVisitor identity() {
		return new ILIdentityVisitor();
	}

	public IVisitor forwardStaged() {
		return new ILForwardStagedVisitor();
	}

	public IBinaryVisitor sequence(IVisitor visitor1, IVisitor visitor2) {
		return new ILSequenceVisitor(ensureSpecific(visitor1),
				ensureSpecific(visitor2));
	}

	public IUnaryVisitor traverseAll(IVisitor visitor1) {
		return new ILTraverseAllVisitor(ensureSpecific(visitor1));
	}
}
