package labss.lang.motomondiale.factories;

import org.whole.lang.factories.GenericEntityFactory;
import labss.lang.motomondiale.model.*;
import org.whole.lang.factories.RegistryConfigurations;
import org.whole.lang.factories.IEntityRegistryProvider;
import labss.lang.motomondiale.reflect.MotoMondialeEntityDescriptorEnum;
import org.whole.lang.factories.IEntityBuilder;
import org.whole.lang.factories.EntityBuilder;
import org.whole.lang.model.IEntity;

/** 
 * @generator Whole
 */
public class MotoMondialeEntityFactory extends GenericEntityFactory {
	public static final MotoMondialeEntityFactory instance = instance(RegistryConfigurations.DEFAULT);

	public static MotoMondialeEntityFactory instance(
			IEntityRegistryProvider provider) {
		return new MotoMondialeEntityFactory(provider);
	}

	protected MotoMondialeEntityFactory(IEntityRegistryProvider provider) {
		super(provider);
	}

	public MotoMondiale createMotoMondiale() {
		return create(MotoMondialeEntityDescriptorEnum.MotoMondiale);
	}

	public MotoMondiale createMotoMondiale(Calendario calendario,
			Circuiti circuiti, Teams teams, Classifiche classifiche) {
		return create(MotoMondialeEntityDescriptorEnum.MotoMondiale,
				calendario, circuiti, teams, classifiche);
	}

	public IEntityBuilder<MotoMondiale> buildMotoMondiale() {
		return new EntityBuilder<MotoMondiale>(
				create(MotoMondialeEntityDescriptorEnum.MotoMondiale));
	}

	public Calendario createCalendario() {
		return create(MotoMondialeEntityDescriptorEnum.Calendario);
	}

	public Calendario createCalendario(Gara... entities) {
		return create(MotoMondialeEntityDescriptorEnum.Calendario,
				(IEntity[]) entities);
	}

	public Calendario createCalendario(int initialSize) {
		return clone(MotoMondialeEntityDescriptorEnum.Calendario, initialSize);
	}

	public Gara createGara() {
		return create(MotoMondialeEntityDescriptorEnum.Gara);
	}

	public Gara createGara(Nome nomeCircuito, Data data,
			OrdineDArrivo ordineDArrivo) {
		return create(MotoMondialeEntityDescriptorEnum.Gara, nomeCircuito,
				data, ordineDArrivo);
	}

	public IEntityBuilder<Gara> buildGara() {
		return new EntityBuilder<Gara>(
				create(MotoMondialeEntityDescriptorEnum.Gara));
	}

	public OrdineDArrivo createOrdineDArrivo() {
		return create(MotoMondialeEntityDescriptorEnum.OrdineDArrivo);
	}

	public OrdineDArrivo createOrdineDArrivo(Nome... entities) {
		return create(MotoMondialeEntityDescriptorEnum.OrdineDArrivo,
				(IEntity[]) entities);
	}

	public OrdineDArrivo createOrdineDArrivo(int initialSize) {
		return clone(MotoMondialeEntityDescriptorEnum.OrdineDArrivo,
				initialSize);
	}

	public Circuiti createCircuiti() {
		return create(MotoMondialeEntityDescriptorEnum.Circuiti);
	}

	public Circuiti createCircuiti(Circuito... entities) {
		return create(MotoMondialeEntityDescriptorEnum.Circuiti,
				(IEntity[]) entities);
	}

	public Circuiti createCircuiti(int initialSize) {
		return clone(MotoMondialeEntityDescriptorEnum.Circuiti, initialSize);
	}

	public Circuito createCircuito() {
		return create(MotoMondialeEntityDescriptorEnum.Circuito);
	}

	public Circuito createCircuito(Nome nome, Nome luogo,
			Numero lunghezzaTracciato, Numero curveADestra,
			Numero curveASinistra, Numero giri) {
		return create(MotoMondialeEntityDescriptorEnum.Circuito, nome, luogo,
				lunghezzaTracciato, curveADestra, curveASinistra, giri);
	}

	public IEntityBuilder<Circuito> buildCircuito() {
		return new EntityBuilder<Circuito>(
				create(MotoMondialeEntityDescriptorEnum.Circuito));
	}

	public Teams createTeams() {
		return create(MotoMondialeEntityDescriptorEnum.Teams);
	}

	public Teams createTeams(Team... entities) {
		return create(MotoMondialeEntityDescriptorEnum.Teams,
				(IEntity[]) entities);
	}

	public Teams createTeams(int initialSize) {
		return clone(MotoMondialeEntityDescriptorEnum.Teams, initialSize);
	}

	public Team createTeam() {
		return create(MotoMondialeEntityDescriptorEnum.Team);
	}

	public Team createTeam(Nome nome, Costruttore costruttore, Pilota pilota1,
			Pilota pilota2) {
		return create(MotoMondialeEntityDescriptorEnum.Team, nome, costruttore,
				pilota1, pilota2);
	}

	public IEntityBuilder<Team> buildTeam() {
		return new EntityBuilder<Team>(
				create(MotoMondialeEntityDescriptorEnum.Team));
	}

	public Pilota createPilota() {
		return create(MotoMondialeEntityDescriptorEnum.Pilota);
	}

	public Pilota createPilota(Nome nome, Numero numero) {
		return create(MotoMondialeEntityDescriptorEnum.Pilota, nome, numero);
	}

	public IEntityBuilder<Pilota> buildPilota() {
		return new EntityBuilder<Pilota>(
				create(MotoMondialeEntityDescriptorEnum.Pilota));
	}

	public Costruttore createCostruttore() {
		return create(MotoMondialeEntityDescriptorEnum.Costruttore);
	}

	public Costruttore createCostruttore(CostruttoreEnum.Value value) {
		return create(MotoMondialeEntityDescriptorEnum.Costruttore, value);
	}

	public Classifiche createClassifiche() {
		return create(MotoMondialeEntityDescriptorEnum.Classifiche);
	}

	public Classifiche createClassifiche(Classifica... entities) {
		return create(MotoMondialeEntityDescriptorEnum.Classifiche,
				(IEntity[]) entities);
	}

	public Classifiche createClassifiche(int initialSize) {
		return clone(MotoMondialeEntityDescriptorEnum.Classifiche, initialSize);
	}

	public Classifica createClassifica() {
		return create(MotoMondialeEntityDescriptorEnum.Classifica);
	}

	public Classifica createClassifica(Nome nome, Classificati classificati) {
		return create(MotoMondialeEntityDescriptorEnum.Classifica, nome,
				classificati);
	}

	public IEntityBuilder<Classifica> buildClassifica() {
		return new EntityBuilder<Classifica>(
				create(MotoMondialeEntityDescriptorEnum.Classifica));
	}

	public Classificati createClassificati() {
		return create(MotoMondialeEntityDescriptorEnum.Classificati);
	}

	public Classificati createClassificati(Classificato... entities) {
		return create(MotoMondialeEntityDescriptorEnum.Classificati,
				(IEntity[]) entities);
	}

	public Classificati createClassificati(int initialSize) {
		return clone(MotoMondialeEntityDescriptorEnum.Classificati, initialSize);
	}

	public Classificato createClassificato() {
		return create(MotoMondialeEntityDescriptorEnum.Classificato);
	}

	public Classificato createClassificato(Nome nome, Numero punti) {
		return create(MotoMondialeEntityDescriptorEnum.Classificato, nome,
				punti);
	}

	public IEntityBuilder<Classificato> buildClassificato() {
		return new EntityBuilder<Classificato>(
				create(MotoMondialeEntityDescriptorEnum.Classificato));
	}

	public Nome createNome() {
		return create(MotoMondialeEntityDescriptorEnum.Nome);
	}

	public Nome createNome(String value) {
		return create(MotoMondialeEntityDescriptorEnum.Nome, value);
	}

	public Numero createNumero() {
		return create(MotoMondialeEntityDescriptorEnum.Numero);
	}

	public Numero createNumero(int value) {
		return create(MotoMondialeEntityDescriptorEnum.Numero, value);
	}

	public Data createData() {
		return create(MotoMondialeEntityDescriptorEnum.Data);
	}

	public Data createData(java.util.Date value) {
		return create(MotoMondialeEntityDescriptorEnum.Data, value);
	}
}
