package labss.lang.regexp.factories;

import org.whole.lang.factories.GenericEntityFactory;
import labss.lang.regexp.model.*;
import org.whole.lang.factories.RegistryConfigurations;
import org.whole.lang.factories.IEntityRegistryProvider;
import labss.lang.regexp.reflect.RegExpEntityDescriptorEnum;
import org.whole.lang.factories.IEntityBuilder;
import org.whole.lang.factories.EntityBuilder;

/** 
 * @generator Whole
 */
public class RegExpEntityFactory extends GenericEntityFactory {
	public static final RegExpEntityFactory instance = instance(RegistryConfigurations.DEFAULT);

	public static RegExpEntityFactory instance(IEntityRegistryProvider provider) {
		return new RegExpEntityFactory(provider);
	}

	protected RegExpEntityFactory(IEntityRegistryProvider provider) {
		super(provider);
	}

	public SequenceExp createSequenceExp() {
		return create(RegExpEntityDescriptorEnum.SequenceExp);
	}

	public SequenceExp createSequenceExp(RegExp exp1, RegExp exp2) {
		return create(RegExpEntityDescriptorEnum.SequenceExp, exp1, exp2);
	}

	public IEntityBuilder<SequenceExp> buildSequenceExp() {
		return new EntityBuilder<SequenceExp>(
				create(RegExpEntityDescriptorEnum.SequenceExp));
	}

	public AlternationExp createAlternationExp() {
		return create(RegExpEntityDescriptorEnum.AlternationExp);
	}

	public AlternationExp createAlternationExp(RegExp alt1, RegExp alt2) {
		return create(RegExpEntityDescriptorEnum.AlternationExp, alt1, alt2);
	}

	public IEntityBuilder<AlternationExp> buildAlternationExp() {
		return new EntityBuilder<AlternationExp>(
				create(RegExpEntityDescriptorEnum.AlternationExp));
	}

	public RepetitionExp createRepetitionExp() {
		return create(RegExpEntityDescriptorEnum.RepetitionExp);
	}

	public RepetitionExp createRepetitionExp(RegExp repetition) {
		return create(RegExpEntityDescriptorEnum.RepetitionExp, repetition);
	}

	public LiteralExp createLiteralExp() {
		return create(RegExpEntityDescriptorEnum.LiteralExp);
	}

	public LiteralExp createLiteralExp(String value) {
		return create(RegExpEntityDescriptorEnum.LiteralExp, value);
	}
}
